export function createEntityFactory() {
    return function createEntity(key) {
        return {
            key: key,
            ids: [],
            all: {},
        };
    };
}
export function insertIntoArray(array, ...values) {
    for (const value of values) {
        const index = array.indexOf(value);
        index < 0 && array.push(value);
    }
}
export function removeFromArray(array, ...values) {
    for (const value of values) {
        const index = array.indexOf(value);
        index < 0 || array.splice(index, 1);
    }
}
export function insertIntoEntity(entity, ...values) {
    for (const value of values) {
        const id = value[entity.key];
        entity.all[id] = value;
        insertIntoArray(entity.ids, id);
    }
}
export function removeFromEntity(entity, ...values) {
    for (const value of values) {
        const id = value[entity.key];
        delete entity.all[id];
        removeFromArray(entity.ids, id);
    }
}
export function removeFromEntityById(entity, ...ids) {
    for (const id of ids) {
        delete entity.all[id];
        removeFromArray(entity.ids, id);
    }
}
