"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function createEntityFactory() {
    return function createEntity(key) {
        return {
            key: key,
            ids: [],
            all: {},
        };
    };
}
exports.createEntityFactory = createEntityFactory;
function insertIntoArray(array) {
    var values = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        values[_i - 1] = arguments[_i];
    }
    for (var _a = 0, values_1 = values; _a < values_1.length; _a++) {
        var value = values_1[_a];
        var index = array.indexOf(value);
        index < 0 && array.push(value);
    }
}
exports.insertIntoArray = insertIntoArray;
function removeFromArray(array) {
    var values = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        values[_i - 1] = arguments[_i];
    }
    for (var _a = 0, values_2 = values; _a < values_2.length; _a++) {
        var value = values_2[_a];
        var index = array.indexOf(value);
        index < 0 || array.splice(index, 1);
    }
}
exports.removeFromArray = removeFromArray;
function insertIntoEntity(entity) {
    var values = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        values[_i - 1] = arguments[_i];
    }
    for (var _a = 0, values_3 = values; _a < values_3.length; _a++) {
        var value = values_3[_a];
        var id = value[entity.key];
        entity.all[id] = value;
        insertIntoArray(entity.ids, id);
    }
}
exports.insertIntoEntity = insertIntoEntity;
function removeFromEntity(entity) {
    var values = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        values[_i - 1] = arguments[_i];
    }
    for (var _a = 0, values_4 = values; _a < values_4.length; _a++) {
        var value = values_4[_a];
        var id = value[entity.key];
        delete entity.all[id];
        removeFromArray(entity.ids, id);
    }
}
exports.removeFromEntity = removeFromEntity;
function removeFromEntityById(entity) {
    var ids = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        ids[_i - 1] = arguments[_i];
    }
    for (var _a = 0, ids_1 = ids; _a < ids_1.length; _a++) {
        var id = ids_1[_a];
        delete entity.all[id];
        removeFromArray(entity.ids, id);
    }
}
exports.removeFromEntityById = removeFromEntityById;
