import { Entity, Value, ValueType, KeyType } from './type-helpers';
export { Entity };
export declare function createEntityFactory<T extends Value>(): <K extends { [K in keyof T]: T[K] extends string | number | symbol ? K : never; }[keyof T]>(key: K) => Entity<T, K>;
export declare function insertIntoArray<T>(array: T[], ...values: T[]): void;
export declare function removeFromArray<T>(array: T[], ...values: T[]): void;
export declare function insertIntoEntity<E extends Entity>(entity: E, ...values: ValueType<E>[]): void;
export declare function removeFromEntity<E extends Entity>(entity: E, ...values: ValueType<E>[]): void;
export declare function removeFromEntityById<E extends Entity>(entity: E, ...ids: KeyType<E>[]): void;
